--
-- decoder.vhd: Adresovy dekoder
--
-- Author: Lucie Matusova, xmatus21, 3BIT

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- ----------------------------------------------------------------------------
--                        Entity declaration
-- ----------------------------------------------------------------------------

entity decoder is
  generic ( 
    ADDR_WIDTH : natural;
	 EN_WIDTH : natural
  );
  port(	
	 INPUT :	in std_logic_vector(ADDR_WIDTH-1 downto 0);
	 EN    :	out std_logic_vector(EN_WIDTH-1 downto 0)
  );
end decoder;

-- ----------------------------------------------------------------------------
--                      Architecture declaration
-- ----------------------------------------------------------------------------

architecture gener of decoder is
begin

	process (INPUT)
	begin
    EN <= (OTHERS => '0');
    for i in 0 to EN_WIDTH-1 loop
		if (INPUT = conv_std_logic_vector(i,ADDR_WIDTH)) then
				EN(i) <= '1';
		end if;
	 end loop;
	end process;

--  EN <= 	
-- 		 "0000001" when I = "0000" else
-- 	    "0000010" when I = "0001" else
--		    "0000100" when I = "0010" else
--		    "0001000" when I = "0011" else
--		    "0010000" when I = "0100" else
--		    "0100000" when I = "0101" else
--		    "1000000" when I = "0110" else		    
--			 "0000000";		

end gener;
